<!DOCTYPE html>
<html lang="en">
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">

<head>
	<title>Modbus Configuration page</title>

	<link rel='stylesheet' type="text/css" href='../css/meti_merged.css'>

	<script src='../js/meti_merged_dt.js'></script>
	<script src='../js/meti_utils.js'></script>

	<style>
		/* html {
			visibility: hidden;
		} */

		.dd-item {
			padding: 0.1rem 0.25rem;
			cursor: pointer;
		}

		.label_title {
			/* font-weight: bold; */
			color: #007bff;
		}

		#button_driver_save {
			font-size: xx-small;
			display: none;
		}

		.table th {
			/* white-space: nowrap; */
			/* width: 1%; */
			padding: 0.5rem;
		}

		.table td {
			/* white-space: nowrap; */
			/* width: 1%; */
			padding: 0.5rem;
		}

		.use_class {
			cursor: pointer;
		}

		.driver_table_div {
			font-size: smaller;
		}

		.driver_use_class {
			width: 20px;
			height: 20px;
		}

		.driver_edit_class {
			text-decoration: underline;
			cursor: pointer;
		}

		#driver_table {
			width: 100% !important;
		}

		#edit_driver_div {
			display: none;
		}
	</style>

</head>

<body>
	<div w3-include-html="meti_bst.html"></div>

	<div class="container m-1">
		<div class="row">
			<main role="main" class="col-md-12 m-1">
				<div class="col-sm-12 border border-primary rounded">
					<div class="row ml-1 mr-1">
						<label class="label_title m-0">Saved drivers in device</label>
						<div id="loader_driver_list" class="meti_loader m-1" style="width:1.5rem; height:1.5rem"></div>
					</div>

					<div class="row ml-1 mr-1 driver_table_div">
						<table id="driver_table" class="table table-primary table-striped table-hover">
							<thead>
								<tr>
									<th scope="col">Sl.</th>
									<th scope="col">Driver Name</th>
									<th scope="col">Edit</th>
									<th scope="col">Speed</th>
									<th scope="col">Parity</th>
									<th scope="col">Stop bits</th>
									<th scope="col">Slave Id</th>
									<th scope="col">Start addr</th>
									<th scope="col">Reg count</th>
									<th scope="col">Read Interval</th>

									<th scope="col">Use</th>
								</tr>
							</thead>
							<tbody id="driver_table_body" class="driver_table_data_class">
								<!-- Driver list comes here... -->
							</tbody>
						</table>
					</div>
				</div>

				<div id="edit_driver_div" class="col-md-6 border border-danger mt-3 rounded">
					<div class="row ml-1 mr-1 d-flex justify-content-center">
						<div id="loader_sel_driver" class="meti_loader m-1" style="width:1.5rem; height:1.5rem"></div>
						<label class="label_title m-0" id="sel_driver">XYZ</label>
					</div>

					<!-- Baud Rate -->
					<div id="baud_div" class="form-group p-0 m-1 row">
						<label class="col-sm-7" for="sel_baud">Baud Rate</label>
						<select class="col-sm-5 form-control form-control-sm" id="sel_baud" name="sel_baud" size="1">
							<option class="dropdown-item" value="0">115200</option>
							<option class="dropdown-item" value="1">57600</option>
							<option class="dropdown-item" value="2">38400</option>
							<option class="dropdown-item" value="3">19200</option>
							<option class="dropdown-item" value="4" selected>9600</option>
							<option class="dropdown-item" value="5">4800</option>
							<option class="dropdown-item" value="6">2400</option>
							<option class="dropdown-item" value="7">1200</option>
							<option class="dropdown-item" value="8">Disabled</option>
						</select>
					</div>

					<!-- Parity -->
					<div id="parity_div" class="form-group p-0 m-1 row">
						<label class="col-sm-7" for="sel_parity">Parity</label>
						<select class="col-sm-5 form-control form-control-sm" id="sel_parity" name="sel_parity"
							size="1">
							<option class="dropdown-item" value="0" selected>None</option>
							<option class="dropdown-item" value="1">Even</option>
							<option class="dropdown-item" value="2">Odd</option>
						</select>
					</div>

					<!-- Stop bits -->
					<!-- Narayan - check the values again -->
					<div class="form-group p-0 m-1 row">
						<label class="col-sm-7" for="sel_stopbits">Stop bits</label>
						<select class="col-sm-5 form-control form-control-sm" id="sel_stopbits" name="sel_stopbits"
							size="1">
							<option class="dropdown-item" value="1" selected>1 bit</option>
							<option class="dropdown-item" value="2">2 bits</option>
						</select>
					</div>

					<!-- Slave/Device Id -->
					<div class="form-group p-0 m-1 row">
						<label class="col-sm-7" for="sel_slaveId">Slave/Device Id</label>
						<select class="col-sm-5 form-control form-control-sm" id="sel_slaveId" name="sel_slaveId"
							size="1">
						</select>
					</div>


					<!-- Retries -->
					<div class="form-group p-0 m-1 row">
						<label class="col-sm-7" for="sel_retries">Retries</label>
						<select class="col-sm-5 form-control form-control-sm" id="sel_retries" name="sel_retries"
							size="1">
						</select>
					</div>

					<!-- Read Interval -->
					<div class="form-group p-0 m-1 row">
						<label class="col-sm-7" for="sel_read_interval">Read Interval (in secs)</label>
						<select class="col-sm-5 form-control form-control-sm" id="sel_read_interval"
							name="sel_read_interval" size="1">
						</select>
					</div>
					<!-- Buttons -->
					<div class="form-group col-sm-12 row justify-content-between m-2">
						<button type="button" id="button_cancel" class="btn btn-warning col-sm-5 m-1">Cancel</button>
						<div id="loader_save" class="meti_loader m-1" style="width:1.5rem; height:1.5rem"></div>
						<button type="button" id="button_save" class="btn btn-success col-sm-5 m-1">Save</button>
					</div>
				</div>
			</main>
		</div>
</body>
</html>



<script>
	w3IncludeHTML();

	var MAX_MODBUS_DRIVERS = 1;
	var modbus_driver_edit = {};

	const tableCols = {
		SLNO: 0,
		DRIVER_NAME: 1,
		EDIT: 2,
		SPEED: 3,
		PARITY: 4,
		STOP_BITS: 5,
		SLAVE_ID: 6,
		START_ADDR: 7,
		REG_COUNT: 8,
		READ_INTERVAL: 9,
		USE: 10
	}

	$(document).ready(function () {
		// display all items
		document.getElementsByTagName("html")[0].style.visibility = "visible";

		setupSelects();

		function setupSelects() {
			// Baud rate options
			for (idx = 1; idx <= 255; idx++) {
				var opt = $('<option></option>')
					.val(idx)
					.addClass('dropdown-item')
					.addClass('dd-item')
					.text(idx);

				$("#sel_slaveId").append(opt);
			}

			// Retries options
			for (idx = 0; idx <= 3; idx++) {
				var opt = $('<option></option>')
					.val(idx)
					.addClass('dropdown-item')
					.addClass('dd-item')
					.text(idx);

				$("#sel_retries").append(opt);
			}

			//read interval options
			read_interval = [3, 5, 10, 15, 30, 60]
			for (idx = 0; idx < read_interval.length; idx++) {
				var opt = $('<option></option>')
					.val(read_interval[idx])
					.addClass('dropdown-item')
					.addClass('dd-item')
					.text(read_interval[idx]);

				$("#sel_read_interval").append(opt);
			}
		}

		function getAllDrivers() {
			var url = "/getAllModbusDrivers"
			if (LOCAL_HOST == true) {
				//Narayan - this will be from meti_api_server
				url = "http://localhost/play/index.php/quickiot_simulate/list_drivers_from_device";
			}

			var type = 'POST';
			var data = {
				app_key: "quickIoT"
			};

			$("#loader_driver_list").css("display", "block");

			$.ajax({
				url: url,
				type: type,
				data: data,
				success: function (response) {
					$("#loader_driver_list").css("display", "none");
					var result = response.result;
					if (result == 1) {
						updateDeviceDrivers(response);
					}
					else if (result == 0) {
						console.log(response.message);
					}
				},
				error: function (jqXHR, exception, response) {
					$("#loader_driver_list").css("display", "none");
					alert('POST Error!! Unable to get Driver list from device...');
				}
			});
		}

		function updateDeviceDrivers(response) {
			table_clear('#driver_table');
			new_table = [];
			$.each(response.driver_list, function (idx, val) {
				var row = [];
				row.push(idx + 1);

				driver_name = val['vendor'] + " - " + val['meter'] + " - " + val['name'];
				row.push(driver_name);

				edit_str = "<label"
					+ " class = 'driver_edit_class'"
					+ " data-driver_id='" + val['driver_id'] + "'"
					+ ">Edit</label>";

				row.push(edit_str)
				row.push(val['baud']);
				row.push(val['parity']);
				row.push(val['stopbits']);
				row.push(val['slaveId']);
				row.push(val['startAddr']);
				row.push(val['regCount']);
				row.push(val['repeat_int']);

				// params = val['params'];
				// if (params.length > 30) {
				// 	row.push(params.substr(0, 25) + ".....");
				// } else {
				// 	row.push(params);
				// }
				use_str = "<input type='checkbox'"
					+ " class = 'driver_use_class'"
					+ " data-driver_id='" + val['driver_id'] + "'"

				if (val["active"] == true) {
					use_str += " checked "
				}
				use_str += ">";

				row.push(use_str);

				new_table.push(row);
			});

			table_add_rows('#driver_table', new_table);

			$(".driver_use_class").on("click", function () {
				var checked_ctr = 0;
				$(".driver_use_class").each(function (idx, val) {
					if ($(this).is(":checked") == true) {
						checked_ctr++;
					}
				});

				if (checked_ctr > MAX_MODBUS_DRIVERS) {
					alert("Only " + MAX_MODBUS_DRIVERS + " driver/s can be selected in this product at a time...\n\nContact vendor for upgradation...");
					$(this).prop("checked", false);
				} else {
					driver_id = $(this).data("driver_id");
					active_status = $(this).is(":checked");
					use_driver(driver_id, active_status);
				}
			});

			$(".driver_edit_class").on("click", function () {
				driver_id = $(this).data('driver_id');

				$("#edit_driver_div").css("display", "block");
				$("#loader_sel_driver").css("display", "block");
				getModbusDriverById(driver_id, edit_driver);
			});

			$('#driver_table').DataTable().order([1, "asc"]).draw();
		}

		function edit_driver(responseJson) {
			modbus_driver_edit = responseJson;

			driver_id = responseJson.driver_id;
			driver_name = responseJson.vendor + " - " + responseJson.meter + " - " + responseJson.name;

			baud = responseJson.serial.baud;
			parity = responseJson.serial.parity;
			stopbits = responseJson.serial.stopbits;

			slaveId = responseJson.command.slaveId;
			retries = responseJson.command.retries;
			read_interval = responseJson.command.repeat_int;

			// If parity is Mark/Space, make it as none...
			if (parity == 3) {
				parity = 0;
			}

			// Max retries limited to 3
			if (retries > 3) {
				retries = 3;
			}

			// If read interval is not there in the list, choose 30 seconds
			if ($("#sel_read_interval option[value=" + read_interval + "]").length == 0) {
				read_interval = 30;
			}

			$("#sel_driver").html(driver_name)
				.data('driver_id', driver_id);

			$("#sel_baud").val(baud);
			$("#sel_parity").val(parity);
			$("#sel_stopbits").val(stopbits);
			$("#sel_slaveId").val(slaveId);
			$("#sel_retries").val(retries);
			$("#sel_read_interval").val(read_interval);

			$("#loader_sel_driver").css("display", "none");
		}

		$("#button_cancel").on("click", function () {
			$("#edit_driver_div").css("display", "none");			
		});

		$("#button_save").on("click", function () {
			var r = confirm("Save Modbus driver configuration?");
			if (r == true) {
				save_driver();
			}
		});

		function use_driver(driver_id, active_status) {
			var debug = 0;

			var url = "/useModbusDriver";
			var type = 'POST';
			var data = {
				driver_id: driver_id,
				active: active_status
			};

			$.ajax({
				url: url,
				type: type,
				data: data,
				success: function (response) {
					if (debug == 1) {
						console.log(response);
					}
					else {
						// console.log(js_response);
						var result = response.result;

						if (result == 1) {
							alert(response.message);
						}
						else if (result == 0) {
							alert(response.message);
						}
					}
				},
				error: function (jqXHR, exception, response) {
					alert('POST Error!');
				}
			});
		}

		function save_driver() {
			var debug = 0;

			driver_id = $("#sel_driver").data('driver_id');

			modbus_driver_edit.serial.baud = $("#sel_baud").val()
			modbus_driver_edit.serial.parity = $("#sel_parity").val()
			modbus_driver_edit.serial.stopbits = $("#sel_stopbits").val()
			modbus_driver_edit.command.slaveId = $("#sel_slaveId").val()
			modbus_driver_edit.command.retries = $("#sel_retries").val()
			modbus_driver_edit.command.repeat_int = $("#sel_read_interval").val()

			var driver_file = JSON.stringify(modbus_driver_edit);
			var data = {};
			data["driver_id"] = driver_id;

			MAX_POST_SIZE = 1000;
			var fileSize = driver_file.length;
			ctr = 0;
			while (fileSize > 0) {
				start = ctr * MAX_POST_SIZE;
				end = start + MAX_POST_SIZE;
				data["driver_file" + ctr] = driver_file.substring(start, end);
				fileSize = fileSize - MAX_POST_SIZE;
				ctr++;
			}
			data['driver_chunks'] = ctr;
			data['fileSize'] = driver_file.length;

			var url = "/saveNewModbusDriver";
			if (LOCAL_HOST == true) {
				url = "http://localhost/play/index.php/quickiot_simulate/save_driver_to_device";
			}
			var type = 'POST';

			$.ajax({
				url: url,
				type: type,
				data: data,
				success: function (response) {
					$("#edit_driver_div").css("display", "none");

					if (debug == 1) {
						console.log(response);
					}
					else {
						// console.log(js_response);
						var result = response.result;

						if (result == 1) {
							getAllDrivers();
							alert(response.message);
						}
						else if (result == 0) {
							alert(response.message);
						}
					}
				},
				error: function (jqXHR, exception, response) {
					alert('POST Error!');
				}
			});
		}

		function driver_list_table_init() {
			var order_by = [[tableCols.DRIVER_NAME, "asc"]];

			$('#driver_table').removeAttr('hidden');

			driver_table = $('#driver_table').DataTable({
				"bSort": false,
				"order": order_by,
				"searching": false,
				"paging": false,
				"bInfo": false,
				"columnDefs": [
					{
						width: '30%',
						targets: [tableCols.DRIVER_NAME, tableCols.PARAMS]
					}
				],
				fixedColumns: true
			});

			driver_table.on('order.dt search.dt', function () {
				driver_table.column(tableCols.SLNO, { search: 'applied', order: 'applied' }).nodes().each(function (cell, i) {
					cell.innerHTML = i + 1;
				});
			}).draw();
		}

		setTimeout(function () {
			getAllDrivers();
			driver_list_table_init();
		}, 750);
	});

</script>